FWUPDMGR(1)

NAME
fwupdmgr - Firmware update manager client utility

DESCRIPTION

  Usage:

    fwupdmgr [OPTION?]

activate [DEVICE-ID|GUID]
    Activate devices

block-firmware [CHECKSUM]
    Blocks a specific firmware from being installed

clear-history
    Erase all firmware update history

clear-offline
    Clears any updates scheduled to be updated offline

clear-results DEVICE-ID|GUID
    Clears the results from the last update

disable-remote REMOTE-ID
    Disables a given remote

downgrade [DEVICE-ID|GUID]
    Downgrades the firmware on a device

enable-remote REMOTE-ID
    Enables a given remote

get-approved-firmware
    Gets the list of approved firmware

get-blocked-firmware
    Gets the list of blocked firmware

get-details FILE
    Gets details about a firmware file

get-devices
    Get all devices that support firmware updates

get-history
    Show history of firmware updates

get-plugins
    Get all enabled plugins registered with the system

get-releases [DEVICE-ID|GUID]
    Gets the releases for a device

get-remotes
    Gets the configured remotes

get-results DEVICE-ID|GUID
    Gets the results from the last update

get-topology
    Alias to get-devices

get-updates [DEVICE-ID|GUID]
    Gets the list of updates for connected hardware

get-upgrades [DEVICE-ID|GUID]
    Alias to get-updates

install FILE [DEVICE-ID|GUID]
    Install a firmware file on this hardware

modify-config KEY,VALUE
    Modifies a daemon configuration value

modify-remote REMOTE-ID KEY VALUE
    Modifies a given remote

refresh [FILE FILE_SIG REMOTE-ID]
    Refresh metadata from remote server

reinstall [DEVICE-ID|GUID]
    Reinstall current firmware on the device

report-history
    Share firmware history with the developers

security
    Gets the host security attributes

set-approved-firmware CHECKSUM1[,CHECKSUM2][,CHECKSUM3]
    Sets the list of approved firmware

switch-branch [DEVICE-ID|GUID] [BRANCH]
    Switch the firmware branch on the device

unblock-firmware [CHECKSUM]
    Unblocks a specific firmware from being installed

unlock DEVICE-ID|GUID
    Unlocks the device for firmware access

update [DEVICE-ID|GUID]
    Updates all firmware to latest versions available

upgrade [DEVICE-ID|GUID]
    Alias to update

verify [DEVICE-ID|GUID]
    Checks cryptographic hash matches firmware

verify-update [DEVICE-ID|GUID]
    Update the stored cryptographic hash with current ROM contents

  Help Options:

-h, --help
    Show help options

  Application Options:

-v, --verbose
    Show extra debugging information

--version
    Show client and daemon versions

--offline
    Schedule installation for next reboot when possible

--allow-reinstall
    Allow reinstalling existing firmware versions

--allow-older
    Allow downgrading firmware versions

--allow-branch-switch
    Allow switching firmware branch

--force
    Force the action by relaxing some runtime checks

-y, --assume-yes
    Answer yes to all questions

--sign
    Sign the uploaded data with the client certificate

--no-unreported-check
    Do not check for unreported history

--no-metadata-check
    Do not check for old metadata

--no-remote-check
    Do not check if download remotes should be enabled

--no-reboot-check
    Do not check for reboot after update

--no-safety-check
    Do not perform device safety checks

--no-history
    Do not write to the history database

--show-all
    Show all results

--disable-ssl-strict
    Ignore SSL strict checks when downloading files

--ipfs
    Only use IPFS when downloading files

--filter
    Filter with a set of device flags using a ~ prefix to exclude, e.g. 'internal,~needs-reboot'

--ignore-power
    Ignore requirement of external power source

This tool allows an administrator to query and control the fwupd daemon, allowing them to perform actions such as installing or downgrading firmware.

SCRIPTING
A variety of client tools are provided by fwupd. Not all tools are suggested to be scripted. fwupdmgr is a command line fwupd client intended to be used interactively. The output between versions of fwupd is not guaranteed to be stable. Commands that succesfully execute will return "0". Commands that have no actions but succesfully execute will return "2". fwupdagent is a command line fwupd client intended to be used by scripts. The output is JSON and guaranteed to be stable. Commands that succesfully execute will return "0".